/*
 * Copyright 2008 Adam Tacy <adam.tacy AT gmail.com>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.adamtacy.client.ui.effects;

/**
 * Simple Handler interface for effects
 * @deprecated Use new GWT 1.6 event model 
 */
public interface NEffectHandler {

  /**
   * Fired when an effect is interrupted.
   * 
   * @param theEffect
   * @deprecated Use new GWT 1.6 event model 
   */
  public void interruptedEvent(NEffect theEffect);

  /**
   * Fired after effect finishing.
   * 
   * @param theEffect
   * @deprecated Use new GWT 1.6 event model 
   */
  public void postEvent(NEffect theEffect);

  /**
   * Fired prior to effects beginning.
   * 
   * @param theEffect
   * @deprecated Use new GWT 1.6 event model 
   */
  public void preEvent(NEffect theEffect);

  /**
   * Fired during effect progression.
   * 
   * @param theEffect
   * @deprecated Use new GWT 1.6 event model 
   */
  public void duringEvent(NEffect theEffect);
}
