/*
 * Copyright 2008 Adam Tacy <adam.tacy AT gmail.com>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.adamtacy.client.ui.effects;

import java.util.Iterator;
import java.util.Vector;

/**
 * Simple object to manage collection of effectHandlers.
 * 
 * @author tacyad
 * @deprecated Use new GWT 1.6 event model 
 * 
 */
@SuppressWarnings( {"serial"})
public class NEffectHandlerCollection extends Vector<NEffectHandler> {

  /**
   * Called when effects are finished.
   * @deprecated Use new GWT 1.6 event model
   */
  public void finishedEffect(NEffect theEffect) {
    for (Iterator<NEffectHandler> it = iterator(); it.hasNext();)
      it.next().postEvent(theEffect);
  }

  /**
   * Called when effects are interupted.
   * 
   * @param theEffect
   * @deprecated Use new GWT 1.6 event model
   */
  public void interruptedEffect(NEffect theEffect) {
    for (Iterator<NEffectHandler> it = iterator(); it.hasNext();)
      it.next().interruptedEvent(theEffect);
  }

  /**
   * Called when effects begin.
   * 
   * @param theEffect
   * @deprecated Use new GWT 1.6 event model
   */
  public void startedEffect(NEffect theEffect) {
    for (Iterator<NEffectHandler> it = iterator(); it.hasNext();)
      it.next().preEvent(theEffect);
  }
  
  /**
   * Called when effects progresses.
   * 
   * @param theEffect
   * @deprecated Use new GWT 1.6 event model
   */
  public void updatedEffect(NEffect theEffect) {
    for (Iterator<NEffectHandler> it = iterator(); it.hasNext();)
      it.next().duringEvent(theEffect);    
  }
}
