/*
 * Copyright 2008 Adam Tacy <adam.tacy AT gmail.com>
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.adamtacy.client.ui.effects.core;

import org.adamtacy.client.ui.effects.NEffect;
import org.adamtacy.client.ui.effects.impl.browsers.EffectImplementation;

import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.ui.SimplePanel;


public class NMorphClip extends NEffect {

  public void setPosition(double progress){
    double val = interpolate(progress);
    this.onUpdate(val);
}
  
  /**
   * Inner class that allows user to set properties of Effect.
   * @deprecated
   */
  public class ClipProperties extends BaseProperties {
    /** Change the ending number 
     * @deprecated
     * */
    public void setEndClip(String newEnd) {
      clipStyleImpl.setEndClip(newEnd);
      if (thePanel != null)
        if (thePanel.isAttached())
          reset();
    }

    /** Change the starting number 
     * @deprecated
     * */
    public void setStartClip(String newStart) {
      clipStyleImpl.setStartClip(newStart);
      if (thePanel != null)
        if (thePanel.isAttached())
          reset();
    }
  }
  
  /** Change the ending number */
  public void setEndClip(String newEnd) {
    clipStyleImpl.setEndClip(newEnd);
    if ((thePanel!=null) && thePanel.isAttached()) reset();
  }

  /** Change the starting number */
  public void setStartClip(String newStart) {
    clipStyleImpl.setStartClip(newStart);
    if ((thePanel!=null) && thePanel.isAttached()) reset();
  }

  NChangeClipAction clipStyleImpl = new NChangeClipAction();

  int originalHeight;

  int originalWidth;

  SimplePanel sp;
  
  /**
   * Internal copy of the properties object
   * @deprecated
   */
  private ClipProperties theClipProperties = new ClipProperties();

  public NMorphClip() {
  }

  /**
   * Expects two CSS entries such as rect(0,0,100,100) rect(0,0,0,0) and will
   * morph between the two.
   * 
   * Format is rect(top, right, bottom, left)
   * 
   * NOTE that we use the W3C preferred approach here of using commas to
   * separate the parameters; our implementation classes will deal with Internet
   * Explorer's alternative approach!
   * 
   * @param startClip
   * @param endClip
   */
  public NMorphClip(String startClip, String endClip) {
    setStartClip(startClip);
    setEndClip(endClip);
  }

  /**
   * Allow the user to retrieve a copy of the properties object.
   * 
   * @return NumberProperties object
   * @deprecated
   */
  public ClipProperties getProperties() {
    return theClipProperties;
  }

  @Override
  protected void onUpdate(double progress) {
    super.onUpdate(progress);
    clipStyleImpl.performStep(effectElement, "clip", progress);
  }

  @Override
  protected void setUpEffect() {
    effectElement = thePanel.getWidget().getElement();
    originalHeight = thePanel.getPanelWidget().getOffsetHeight();
    originalWidth = thePanel.getPanelWidget().getOffsetWidth();
    // DOM.setStyleAttribute(effectElement, "overflow", "hidden");
    DOM.setStyleAttribute((com.google.gwt.user.client.Element) effectElement,
        "position", "absolute");
    clipStyleImpl.setUp(effectElement, "clip", 0);
  }

  @Override
  public void tearDownEffect() {
    DOM.setStyleAttribute((com.google.gwt.user.client.Element) effectElement,
        "overflow", "visible");
    DOM.setStyleAttribute((com.google.gwt.user.client.Element) effectElement,
        "position", "relative");
    clipStyleImpl.tearDownEffect(effectElement);
    EffectImplementation.clip(effectElement, 0 + "px", 0 + "px", originalHeight
        + "px", originalWidth + "px");
  }
}
