package org.adamtacy.client.ui.effects.impl;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import org.adamtacy.client.ui.effects.NEffect;
import org.adamtacy.client.ui.effects.NEffectCollection;
import org.adamtacy.client.ui.effects.core.ChangeInterface;
import org.adamtacy.client.ui.effects.core.NChangeScalarAction;
import org.adamtacy.client.ui.effects.impl.css.StyleImplementation;

import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.DeferredCommand;
import com.google.gwt.user.client.Element;
import com.google.gwt.user.client.ui.ComplexPanel;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTMLTable;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.Panel;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.client.ui.HasHorizontalAlignment.HorizontalAlignmentConstant;
import com.google.gwt.user.client.ui.HasVerticalAlignment.VerticalAlignmentConstant;

public class Resize2 extends NEffect {

  /**
   * Inner class representing the properties that may be altered by the user.
   * 
   * @deprecated
   */
  public class ResizeProperties extends BaseProperties {

    /**
     * Set the ending height for the resize.
     * 
     * @param percentage Ending height in percentage.
     * @deprecated
     */
    public void setEndHeightPercentage(int percentage) {
      endY = percentage;
    }

    /**
     * Set the ending width for the resize.
     * 
     * @param percentage Ending width in percentage.
     * @deprecated
     */
    public void setEndWidthPercentage(int percentage) {
      endX = percentage;
    }

    /**
     * @deprecated
     * @param newHorizAlign
     */
    public void setHorizAlignment(HorizontalAlignmentConstant newHorizAlign) {
      horizAlign = newHorizAlign;
    }

    /**
     * Set the starting height for the resize.
     * 
     * @param percentage Starting height in percentage.
     * @deprecated
     */
    public void setStartHeightPercentage(int percentage) {
      startY = percentage;
    }

    /**
     * Set the starting width for the resize.
     * 
     * @param percentage Starting width in percentage.
     * @deprecated
     */
    public void setStartWidthPercentage(int percentage) {
      startX = percentage;
    }

    /**
     * @deprecated
     * @param newVertAlign
     */
    public void setVertAlignment(VerticalAlignmentConstant newVertAlign) {
      vertAlign = newVertAlign;
    }
  }

  /**
   * Set the ending height for the resize.
   * 
   * @param percentage Ending height in percentage.
   */
  public void setEndHeightPercentage(int percentage) {
    endY = percentage;
  }

  /**
   * Set the ending width for the resize.
   * 
   * @param percentage Ending width in percentage.
   */
  public void setEndWidthPercentage(int percentage) {
    endX = percentage;
  }

  public void setHorizAlignment(HorizontalAlignmentConstant newHorizAlign) {
    horizAlign = newHorizAlign;
  }

  /**
   * Set the starting height for the resize.
   * 
   * @param percentage Starting height in percentage.
   */
  public void setStartHeightPercentage(int percentage) {
    startY = percentage;
  }

  /**
   * Set the starting width for the resize.
   * 
   * @param percentage Starting width in percentage.
   */
  public void setStartWidthPercentage(int percentage) {
    startX = percentage;
  }

  public void setVertAlignment(VerticalAlignmentConstant newVertAlign) {
    vertAlign = newVertAlign;
  }

  public Resize2() {
    super();
  }

  public Resize2(int start, int end) {
    super();
    startX = start;
    startY = start;
    endX = end;
    endY = end;
  }

  HashMap<Element, Vector<ChangeInterface>> determinedXEffects = new HashMap<Element, Vector<ChangeInterface>>();
  HashMap<Element, Vector<ChangeInterface>> determinedYEffects = new HashMap<Element, Vector<ChangeInterface>>();

  NEffectCollection e = new NEffectCollection();

  int endX = 0;
  double endXRatio;
  int endY = 0;
  double endYRatio;

  HorizontalAlignmentConstant horizAlign = HasHorizontalAlignment.ALIGN_LEFT;

  int startX = 100;

  double startXRatio;

  int startY = 100;

  double startYRatio;

  /**
   * Internal properties object
   */
  private ResizeProperties theGrowProperties = new ResizeProperties();

  VerticalAlignmentConstant vertAlign = HasVerticalAlignment.ALIGN_TOP;

  /**
   * Recurse over widgets in a widget
   * 
   * @param currWidget
   */
  private void createInternalEffectsPerElement(Widget currWidget) {
    if (currWidget instanceof Panel) {
      if (currWidget instanceof SimplePanel) {
        createInternalEffectsPerElement(((SimplePanel) currWidget).getWidget());
      } else if ((currWidget instanceof ComplexPanel)) {
        for (Iterator<Widget> it = ((ComplexPanel) currWidget).iterator(); it.hasNext();) {
          Widget component = it.next();
          createInternalEffectsPerElement(component);
        }
      } else if ((currWidget instanceof HTMLTable)) {
        for (Iterator<Widget> it = ((HTMLTable) currWidget).iterator(); it.hasNext();) {
          Widget component = it.next();
          createInternalEffectsPerElement(component);
        }
      }
    } else {
      if (currWidget instanceof Composite) {
        createInternalEffectsPerElement(getCompositeWidget(currWidget));
      }
    }

    Vector<ChangeInterface> tempX = new Vector<ChangeInterface>();
    Vector<ChangeInterface> tempY = new Vector<ChangeInterface>();

    // TODO: Need to find a way of stopping Opera wrapping text as it shrinks

    int startWidth = getStartWidth(currWidget);
    int endWidth = getEndWidth(currWidget);
    NChangeScalarAction theWidthChange = new NChangeScalarAction(startWidth
        + "px", endWidth + "px");
    theWidthChange.setUp(currWidget.getElement(), "width", 0);
    tempX.add(theWidthChange);

    int startHeight = getStartHeight(currWidget);
    int endHeight = getEndHeight(currWidget);
    NChangeScalarAction theHeightChange = new NChangeScalarAction(startHeight
        + "px", endHeight + "px");
    theHeightChange.setUp(currWidget.getElement(), "height", 0);
    tempY.add(theHeightChange);

    if (horizAlign != HasHorizontalAlignment.ALIGN_LEFT) {
      int startLeft = getStartLeft(thePanel);
      int endLeft = getEndLeft(thePanel);
      NChangeScalarAction theLeftChange = new NChangeScalarAction(startLeft
          + "px", endLeft + "px");
      theLeftChange.setUp(currWidget.getElement(), "left", 0);
      tempX.add(theLeftChange);
    }
    if (vertAlign != HasVerticalAlignment.ALIGN_TOP) {
      int startTop = getStartTop(thePanel);
      int endTop = getEndTop(thePanel);

      NChangeScalarAction theTopChange = new NChangeScalarAction(startTop
          + "px", endTop + "px");
      theTopChange.setUp(currWidget.getElement(), "top", 0);
      tempY.add(theTopChange);
    }
    String res = StyleImplementation.getComputedStyle(currWidget.getElement(),
        "fontSize");
    if (res != null) {
      String unit = StyleImplementation.getUnits(res);
      int startFontSize = (int) (new Double(StyleImplementation.getValue(res,
          unit)).doubleValue() * startXRatio);
      int endFontSize = (int) (new Double(StyleImplementation.getValue(res,
          unit)).doubleValue() * endXRatio);
      NChangeScalarAction theFontChange = new NChangeScalarAction(startFontSize
          + unit, endFontSize + unit);
      theFontChange.setUp(currWidget.getElement(), "fontSize", 0);
      tempX.add(theFontChange);
    }
    determinedXEffects.put(currWidget.getElement(), tempX);
    determinedYEffects.put(currWidget.getElement(), tempY);
  }

  /**
   * Simple work around to get the widget from a composite which is not
   * accessible directly via GWT, so we need to play with JSNI a little.
   * 
   * @param theCompositeWidget
   * @return
   */
  private native Widget getCompositeWidget(Widget theCompositeWidget)/*-{
              return theCompositeWidget.@com.google.gwt.user.client.ui.Composite::widget;
            }-*/;

  protected int getEndHeight(Widget theWidget) {
    return (int) (theWidget.getOffsetHeight() * endYRatio);
  }

  protected int getEndLeft(Widget theWidget) {
    if (horizAlign == HasHorizontalAlignment.ALIGN_RIGHT) {
      return (int) (((double) theWidget.getOffsetWidth() / 2 - theWidget.getOffsetWidth()
          * endXRatio) / 2);
    } else {
      return (int) ((theWidget.getOffsetWidth() - theWidget.getOffsetWidth()
          * endXRatio) / 4);
    }
  }

  protected int getEndTop(Widget theWidget) {
    if (vertAlign == HasVerticalAlignment.ALIGN_BOTTOM) {
      return (int) ((double) theWidget.getOffsetHeight() / 2)
          - (int) (theWidget.getOffsetHeight() * endYRatio / 2);
    } else {
      return (int) ((double) theWidget.getOffsetHeight() / 4)
          - (int) (theWidget.getOffsetHeight() * endYRatio / 4);
    }
  }

  protected int getEndWidth(Widget theWidget) {
    return (int) (theWidget.getOffsetWidth() * endXRatio);
  }

  /**
   * Return a copy of the internal properties object to the user
   * 
   * @return
   */
  public ResizeProperties getProperties() {
    return theGrowProperties;
  }

  protected int getStartHeight(Widget theWidget) {
    return (int) (theWidget.getOffsetHeight() * startYRatio);
  }

  protected int getStartLeft(Widget theWidget) {
    if (horizAlign == HasHorizontalAlignment.ALIGN_RIGHT) {
      return (int) ((theWidget.getOffsetWidth() - theWidget.getOffsetWidth()
          * startXRatio) / 2);
    } else {
      return (int) ((theWidget.getOffsetWidth() - theWidget.getOffsetWidth()
          * startXRatio) / 4);
    }
  }

  protected int getStartTop(Widget theWidget) {
    if (vertAlign == HasVerticalAlignment.ALIGN_BOTTOM) {
      return (int) ((double) theWidget.getOffsetHeight() / 2)
          - (int) (theWidget.getOffsetHeight() * startYRatio / 2);
    } else {
      return (int) ((double) theWidget.getOffsetHeight() / 4)
          - (int) (theWidget.getOffsetHeight() * startYRatio / 4);
    }
  }

  protected int getStartWidth(Widget theWidget) {
    double w = theWidget.getOffsetWidth();
    double v = w * startXRatio;
    return (int) v;
  }

  protected void onUpdateX(double progress) {
    for (Iterator<Element> it = determinedXEffects.keySet().iterator(); it.hasNext();) {
      Element theChange = it.next();
      Vector<ChangeInterface> currChange = determinedXEffects.get(theChange);
      for (int loop = 0; loop < currChange.size(); loop++) {
        currChange.get(loop).performStep(theChange, "", progress);
      }
    }
  }

  protected void onUpdateY(double progress) {
    for (Iterator<Element> it = determinedYEffects.keySet().iterator(); it.hasNext();) {
      Element theChange = it.next();
      Vector<ChangeInterface> currChange = determinedYEffects.get(theChange);
      for (int loop = 0; loop < currChange.size(); loop++) {
        currChange.get(loop).performStep(theChange, "", progress);
      }
    }
  }

  @Override
  protected void onUpdate(double progress) {
    super.onUpdate(progress);
    onUpdateX(progress);
    onUpdateY(progress);
  }

  public void setPosition(double progress) {
    double val = interpolate(progress);
    this.onUpdate(val);
  }

  public void setPositionX(double progress) {
    double val = interpolate(progress);
    this.onUpdateX(val);
  }

  public void setPositionY(double progress) {
    double val = interpolate(progress);
    this.onUpdateY(val);
  }

  @Override
  protected void setUpEffect() {

    startXRatio = (double) startX / 100;
    startYRatio = (double) startY / 100;
    endXRatio = (double) endX / 100;
    endYRatio = (double) endY / 100;

    DeferredCommand.addCommand(new Command() {
      public void execute() {
        createInternalEffectsPerElement(thePanel.getWidget());
      }
    });
  }

  @Override
  public void tearDownEffect() {
    for (Iterator<Element> it = determinedXEffects.keySet().iterator(); it.hasNext();) {
      Element theChange = it.next();
      Vector<ChangeInterface> currChange = determinedXEffects.get(theChange);
      for (int loop = 0; loop < currChange.size(); loop++) {
        currChange.get(loop).performStep(theChange, "", 0);
      }
    }
    for (Iterator<Element> it = determinedYEffects.keySet().iterator(); it.hasNext();) {
      Element theChange = it.next();
      Vector<ChangeInterface> currChange = determinedYEffects.get(theChange);
      for (int loop = 0; loop < currChange.size(); loop++) {
        currChange.get(loop).performStep(theChange, "", 0);
      }
    }
  }

}
