package org.adamtacy.client.ui.effects.impl;

import org.adamtacy.client.ui.effects.core.NMorphStyle;
import org.adamtacy.client.ui.effects.events.EffectSteppingEvent;
import org.adamtacy.client.ui.effects.events.EffectSteppingHandler;
import org.adamtacy.client.ui.effects.impl.css.Rule;

import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.DeferredCommand;

public class SlideBase extends NMorphStyle{

  /**
   * Inner class that allows user to set properties of Effect.
   * @deprecated
   */
  public class SlideProperties extends StyleProperties {
    /**
     * @deprecated
     * @param newValue
     */
    public void setDisplayOutsideBounds(boolean newValue){
      displayOutsideBounds = newValue;
    }
  }
  
  public void setDisplayOutsideBounds(boolean newValue){
    displayOutsideBounds = newValue;
  }
  
  /**
   * @deprecated
   */
  private SlideProperties theSlideProperties;
  
  /**
   * @deprecated
   * @return
   */
  public SlideProperties getSlideProperties(){
    if (theSlideProperties==null) theSlideProperties = new SlideProperties();
    return theSlideProperties;
  }
  
  public SlideBase() {
    super(new Rule("slideStart{left: -400px; top: -400px; }"), new Rule("slideEnd{left: 0px; top: 0px; }"));
  }
  
  public void setNewStartStyle(Rule start){
    registerProperties(start, theEnd);
    theStart = start;
    super.setUpEffect();
  }
  
  protected String newEnd;
  protected int height;
  protected int width;
  protected boolean displayOutsideBounds = false;
  
  protected void setUpEffect(final Command command){  
    DOM.setStyleAttribute(thePanel.getElement(), "overflow", "hidden");
    // Need to call set up first, so that the panel gets hidden before being displayed
    // Dimensions are set up in Deferred Command below, which might take longer to execute than
    // the control back in the NEffect which displays the widget.  BY setting the initial effect to
    // large values in the constructor, we can then immediately hide this panel by position, then the
    // deferred command can do its work and place it where needed for sliding in.
    super.setUpEffect();
    DeferredCommand.addCommand(new Command() {
      public void execute() {
        height = thePanel.getWidget().getOffsetHeight();
        width = thePanel.getWidget().getOffsetWidth();
        command.execute();
        setNewStartStyle(new Rule(newEnd));
      }
    });
    // This change listener will allow the panel to be visible outside of bounding box (for example
    // we would like this on the elastic transition physics so that once the effect is greater than 1.0
    // we display, and below 1.0 we hide overshots.
    // However, since this is only really applicable to the elastic transition physics and would carry an overhead
    // for others, we allow a boolean to indicate if available or not.
    if(displayOutsideBounds){
      this.addEffectSteppingHandler(new EffectSteppingHandler(){
        public void onEffectStep(EffectSteppingEvent handler) {
          if(getProgress()>1) 
            DOM.setStyleAttribute(thePanel.getElement(), "overflow", "visible");
          if(getProgress()<1)
            DOM.setStyleAttribute(thePanel.getElement(), "overflow", "hidden");            
        }
      });
    }
  }
  
  public void tearDownEffect(){
    DOM.setStyleAttribute((com.google.gwt.user.client.Element) effectElement, "top", DOM.getStyleAttribute(thePanel.getElement(),"top"));
    DOM.setStyleAttribute((com.google.gwt.user.client.Element) effectElement, "left", DOM.getStyleAttribute(thePanel.getElement(),"left"));
    DOM.setStyleAttribute(thePanel.getElement(), "overflow", "visible");
  }
}
